zoukankan      html  css  js  c++  java
  • [洛谷P3527] [POI2011]MET-Meteors

    洛谷题目链接:[POI2011]MET-Meteors

    题意翻译

    Byteotian Interstellar Union有N个成员国。现在它发现了一颗新的星球,这颗星球的轨道被分为M份(第M份和第1份相邻),第i份上有第Ai个国家的太空站。 这个星球经常会下陨石雨。BIU已经预测了接下来K场陨石雨的情况。 BIU的第i个成员国希望能够收集Pi单位的陨石样本。你的任务是判断对于每个国家,它需要在第几次陨石雨之后,才能收集足够的陨石。

    输入: 第一行是两个数N,M。 第二行有M个数,第i个数Oi表示第i段轨道上有第Oi个国家的太空站。 第三行有N个数,第i个数Pi表示第i个国家希望收集的陨石数量。 第四行有一个数K,表示BIU预测了接下来的K场陨石雨。 接下来K行,每行有三个数Li,Ri,Ai,表示第K场陨石雨的发生地点在从Li顺时针到Ri的区间中(如果Li<=Ri,就是Li,Li+1,…,Ri,否则就是Ri,Ri+1,…,m-1,m,1,…,Li),向区间中的每个太空站提供Ai单位的陨石样本。

    输出:N行。第i行的数Wi表示第i个国家在第Wi波陨石雨之后能够收集到足够的陨石样本。如果到第K波结束后仍然收集不到,输出NIE。

    数据范围:1<=n,m,k<=3*10^5 1<=Pi<=10^9 1<=Ai<10^9

    感谢@noco 提供的翻译

    题目描述

    Byteotian Interstellar Union (BIU) has recently discovered a new planet in a nearby galaxy. The planet is unsuitable for colonisation due to strange meteor showers, which on the other hand make it an exceptionally interesting object of study.

    The member states of BIU have already placed space stations close to the planet's orbit. The stations' goal is to take samples of the rocks flying by.
    The BIU Commission has partitioned the orbit into (m) sectors, numbered from (1) to (m), where the sectors (1) and (m) are adjacent. In each sector there is a single space station, belonging to one of the (n) member states.

    Each state has declared a number of meteor samples it intends to gather before the mission ends. Your task is to determine, for each state, when it can stop taking samples, based on the meter shower predictions for the years to come.

    给定一个环,每个节点有一个所属国家,k次事件,每次对[l,r]区间上的每个点点权加上一个值,求每个国家最早多少次操作之后所有点的点权和能达到一个值

    输入输出格式

    输入格式:
    The first line of the standard input gives two integers, (n) and (m) ((1le n,mle 300 000)), separated by a single space, that denote,respectively, the number of BIU member states and the number of sectors the orbit has been partitioned into.

    In the second line there are (m) integers (o_i) ((1le o_ile n)),separated by single spaces, that denote the states owning stations in successive sectors.
    In the third line there are (n) integers (p_i) ((1le p_ile 10^9)),separated by single spaces, that denote the numbers of meteor samples that the successive states intend to gather.

    In the fourth line there is a single integer (k) ((1le kle 300 000)) that denotes the number of meteor showers predictions. The following (k) lines specify the (predicted) meteor showers chronologically. The (i)-th of these lines holds three integers (l_i,r_i,a_i) (separated by single spaces), which denote that a meteor shower is expected in sectors (l_i,l_{i+1},...,r_i)(if (l_ile r_i)) or sectors (l_i,l_{i+1},...,m,1,...,r_i) (if (l_i > r_i)) , which should provide each station in those sectors with (a_i) meteor samples ((1le a_ile 10^9)).

    输出格式:

    Your program should print (n) lines on the standard output.
    The (i)-th of them should contain a single integer (w_i), denoting the number of shower after which the stations belonging to the (i)-th state are expected to gather at least (p_i) samples, or the word NIE (Polish for no) if that state is not expected to gather enough samples in the foreseeable future.

    输入输出样例

    输入样例#1:
    3 5
    1 3 2 1 3
    10 5 7
    3
    4 2 4
    1 3 1
    3 5 2

    输出样例#1:
    3
    NIE
    1

    说明

    给定一个环,每个节点有一个所属国家,k次事件,每次对[l,r]区间上的每个点点权加上一个值,求每个国家最早多少次操作之后所有点的点权和能达到一个值

    一句话题意: 一个长度为(m)的环形轨道上有(m)个位置,分别属于(n)个国家,每个国家需要收集一定的陨石,有(k)次流星雨,会在([l,r])的区间内掉落一定的陨石(如果(l>r)则在([1,r]),([l,m])的区间内掉落.问每个国家最少要多少次可以得到足够的陨石.

    题解: 考虑处理一次询问,显然这个次数是具有单调性的,也就是说,次数越多,就越可能达到需要.所以可以二分这个陨石发生的次数,并且每次在改变状态的时候用树状数组区间修改,对于该国家的所有占有地区单点查询,这样一次的时间复杂度是(O(k*log_2m+n*log_2m))的.

    然后我们发现,每次二分出下了(mid)次流星雨,都可以对所有的询问作贡献,这样我们就可以用整体二分的思想,将所有询问一起处理.对于每一个国家统计当前状态下已经拥有的陨石数,直接将这个国家管辖的地区用(vector)保存,然后每次询问就多次单点查询来实现.虽然每个国家有多个地区,但是地区总数只有(m)个,也就是说这样做的复杂度只有(O(log_2m*m*log_2k)).

    然后一个可以优化的就是,每次二分了一个(mid)表示已经进行了(mid)场流星雨,那么在修改的时候可以直接由上一次的状态修改过来(记录一个(now)表示当前修改到了第(now)场流星雨,每次进入下一层递归的时候(now)就是上一次的状态了.

    还要注意一下在查询的时候可能爆long long,如果大于可以直接返回防止爆long long.

    #include<bits/stdc++.h>
    using namespace std;
    const int N = 3e5+5;
    typedef int _int;
    #define int long long
    
    int n, m, k, id[N], c[N], vis[N], now = 0, t1[N], t2[N];
    
    vector <int> ve[N];
    
    struct country{
        int ans, k;
    }a[N];
    
    struct Change{
        int l, r, k;
    }b[N];
    
    int gi(){
        int ans = 0, f = 1; char i = getchar();
        while(i<'0' || i>'9'){ if(i == '-') f = -1; i = getchar(); }
        while(i>='0' && i<='9') ans = ans*10+i-'0', i = getchar();
        return ans * f;
    }
    
    int lowbit(int x){ return x&-x; }
    
    void update(int x, int val){ for(;x<=m;x+=lowbit(x)) c[x] += val; }
    
    int query(int x){
        int res = 0;
        for(;x;x-=lowbit(x)) res += c[x];
        return res;
    }
    
    void change(Change x, int val){
        if(val){
    	if(x.l <= x.r) update(x.l, x.k), update(x.r+1, -x.k);
    	else update(1, x.k), update(x.r+1, -x.k), update(x.l, x.k);
        } else {
    	if(x.l <= x.r) update(x.l, -x.k), update(x.r+1, x.k);
    	else update(1, -x.k), update(x.r+1, x.k), update(x.l, -x.k);
        }
    }
    
    int ask(int x, int lim){
        int res = 0;
        for(int i=0;i<ve[x].size();i++){
    	res += query(ve[x][i]);
    	if(res > lim) return res;
        }
        return res;
    }
    
    void solve(int l, int r, int ql, int qr){
        if(ql > qr) return;
        if(l == r){
    	for(int i=ql;i<=qr;i++) a[id[i]].ans = l;
    	return;
        }
        int mid = (l+r>>1), cnt1 = 0, cnt2 = 0, cnt = ql-1;
        while(now < mid) change(b[++now], 1);
        while(now > mid) change(b[now--], 0);
        for(int i=ql;i<=qr;i++){
    	int sum = ask(id[i], a[id[i]].k);
    	if(sum >= a[id[i]].k) t1[++cnt1] = id[i];
    	else t2[++cnt2] = id[i];
        }
        for(int i=1;i<=cnt1;i++) id[++cnt] = t1[i];
        for(int i=1;i<=cnt2;i++) id[++cnt] = t2[i];
        solve(l, mid, ql, ql+cnt1-1), solve(mid+1, r, ql+cnt1, qr);
    }
    
    _int main(){
        int x; n = gi(), m = gi();
        for(int i=1;i<=m;i++) x = gi(), ve[x].push_back(i);
        for(int i=1;i<=n;i++) a[i].k = gi(), id[i] = i;
        k = gi();
        for(int i=1;i<=k;i++) b[i].l = gi(), b[i].r = gi(), b[i].k = gi();
        b[++k].l = 1, b[k].r = m, b[k].k = 0x3f3f3f3f;
        solve(1, k, 1, n);
        for(int i=1;i<=n;i++){
    	if(a[i].ans == k) printf("NIE
    ");
    	else printf("%lld
    ", a[i].ans);
        }
        return 0;
    }
    
    
  • 相关阅读:
    prase arraylist where in to ParamsQuery on sql server 2008 using TVB: tvpdemo.cs(where in 转sql 参数化查询)
    手动依赖性注入 NInject(1) (转载)
    单件(单态,Singleton)模式部分
    详解Javascript中的Url编码/解码
    学习Web应用漏洞最好的教程WebGoat(转载)
    百度网盘 邀请码
    colorbox去除close关闭按钮,附上colorbox的基本使用方法
    P3974 [TJOI2015]组合数学
    P1772 [ZJOI2006]物流运输
    P1434 [SHOI2002]滑雪
  • 原文地址:https://www.cnblogs.com/BCOI/p/9591490.html
Copyright © 2011-2022 走看看